#include "stdlib.h"
#include "1289LCD.h"
#include "font.h"

//ɫ,ɫ
u16 POINT_COLOR = 0x0000,BACK_COLOR = 0xFFFF; 

/******************************************/
	/*       		  */
/******************************************/
void LCD_DATAOUT(u16 data)
{
   GPIOB->CRL=0X33333333; //PB0-7  
   GPIOB->CRH=0X33333333; //PB8-15  
   GPIO_Write(GPIOB, data);
}
/******************************************/
	/*       		  */
/******************************************/
u16 LCD_DATAIN()
{
    u16 data;
  	GPIOB->CRL=0X88888888; //PB0-7  
	GPIOB->CRH=0X88888888; //PB8-15 
	GPIOB->ODR=0XFFFF;    //ȫ 
    data=GPIOB->IDR;
    return data;
}
/******************************************/
	/*       Ƭѡ1		  */
/******************************************/
void LCD_CS_SET()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_9);
}
/********************************************/
/* RS/ݱ־0д1дݣ*/
/********************************************/
void LCD_RS_SET()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_8);
}
/********************************************/
            /* WRд*/
/********************************************/
void LCD_WR_SET()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_7);
}
/********************************************/
           /* RD:*/
/********************************************/
void LCD_RD_SET()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_6);
}

/******************************************/
	   /*       Ƭѡ0		   */
/******************************************/	  
void LCD_CS_CLR()
{
	GPIO_ResetBits(GPIOC, GPIO_Pin_9);
}
/********************************************/
/* RS/ݱ־0д1дݣ*/
/********************************************/
void LCD_RS_CLR()
{
	GPIO_ResetBits(GPIOC, GPIO_Pin_8);
}
/********************************************/
            /* WRд*/
/********************************************/
void LCD_WR_CLR()
{
	GPIO_ResetBits(GPIOC, GPIO_Pin_7);
}
/********************************************/
           /* RD:*/
/********************************************/
void LCD_RD_CLR()
{
	GPIO_ResetBits(GPIOC, GPIO_Pin_6);
}
/********************************************/
           /* LCD*/
/********************************************/
void LCD_LEDON()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_10);
}
/********************************************/
           /* رLCD*/
/********************************************/
void LCD_LEDOFF()
{
	GPIO_SetBits(GPIOC, GPIO_Pin_10);
}

/********************************************/
           /* дĴ*/
/********************************************/
void LCD_WR_REG(u16 data)
{ 
	LCD_RS_CLR();//дַ  
 	LCD_CS_CLR(); 
	LCD_DATAOUT(data); 
	LCD_WR_CLR(); 
	LCD_WR_SET(); 
 	LCD_CS_SET();   
}
/********************************************/
           /* д8λݺ*/
/********************************************/
void LCD_WR_DATA(u16 data)
{
	LCD_RS_SET();
	LCD_CS_CLR();
	LCD_DATAOUT(data);
	LCD_WR_CLR();
	LCD_WR_SET();
	LCD_CS_SET();
} 
/********************************************/
             /* дĴ*/
/********************************************/
void LCD_WriteReg(u16 LCD_Reg, u16 LCD_RegValue)
{	
	LCD_WR_REG(LCD_Reg);  
	LCD_WR_DATA(LCD_RegValue);	    		 
}
/********************************************/
             /* Ĵ*/
/********************************************/
u16 LCD_ReadReg(u16 LCD_Reg)
{										   
	u16 t;
	LCD_WR_REG(LCD_Reg);  //дҪļĴ  
	LCD_RS_SET();
	LCD_CS_CLR();
	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD_CLR();
	delay_nus(5);//FOR 8989,ʱ5us					   
	LCD_RD_SET();
	t=LCD_DATAIN(); 
	LCD_CS_SET(); 
	return t; 
} 
/********************************************/
             /* ʼдGRAM*/
/********************************************/
void LCD_WriteRAM_Prepare(void)
{
	LCD_WR_REG(R34);
}
/********************************************/
             /* LCDдGRAM*/
/********************************************/
void LCD_WriteRAM(u16 RGB_Code)
{							    
	LCD_WR_DATA(RGB_Code);//дʮλGRAM
}
/*******************************************/
//ȡĳɫֵ	 
//x:0~239
//y:0~319
//ֵ:˵ɫ
/*******************************************/
u16 LCD_ReadPoint(u16 x,u16 y)
{
	u16 t;	
	if(x>=LCD_W||y>=LCD_H)return 0;//˷Χ,ֱӷ		   
	LCD_SetCursor(x,y);
	LCD_WR_REG(R34);       //ѡGRAMַ 
	LCD_RS_SET();
	LCD_CS_CLR();
	//ȡ(GRAMʱ,Ҫ2)
	LCD_RD_CLR();					   
	LCD_RD_SET();
	delay_nus(2);//FOR 9320,ʱ2us					   
	//dummy READ
	LCD_RD_CLR();					   
	delay_nus(2);//FOR 8989,ʱ2us					   
	LCD_RD_SET();
	t=LCD_DATAIN();  
	LCD_CS_SET(); 
	return t;//4531/8989IC
}
/********************************************/
             /* LCDʾ*/
/********************************************/
void LCD_DisplayOn(void)
{					   
	LCD_WriteReg(R7, 0x0173); //26ɫʾ
}
/********************************************/
             /* LCDرʾ*/
/********************************************/	 
void LCD_DisplayOff(void)
{	   
	LCD_WriteReg(R7, 0x0);//رʾ 
} 
/******************************************/
//ùλ
//Xpos:
//Ypos:
/*****************************************/
__inline void LCD_SetCursor(u16 Xpos, u16 Ypos)
{

	LCD_WriteReg(0X4E, Xpos);
	LCD_WriteReg(0X4F, Ypos); 						    
} 
/*****************************************/
//
//x:0~239
//y:0~319
//POINT_COLOR:˵ɫ
/****************************************/
void LCD_DrawPoint(u16 x,u16 y)
{
	LCD_SetCursor(x,y);//ùλ 
	LCD_WR_REG(R34);//ʼдGRAM
	LCD_WR_DATA(POINT_COLOR); 
} 
/********************************************/
             /* LCDʼ*/
/********************************************/
void LCD_Init(void)
{ 
    GPIO_InitTypeDef GPIO_InitStructure;

 	RCC->APB2ENR|=1<<3;//ʹPORTBʱ
 	RCC->APB2ENR|=1<<4;//ʹPORTCʱ

	RCC->APB2ENR|=1<<0;    //ʱ

GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable , ENABLE);	//JTAG-DP ʧ + SW-DPʹ 
											 
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); 
	GPIO_Write(GPIOC, (GPIO_ReadOutputData(GPIOC)|0X07C0));//GPIOC->ODR|=0X07C0;	 

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_Write(GPIOB, 0XFFFF);	 //GPIOB->ODR=0XFFFF;  	
					 
	delay_nms(50); // delay 50 ms 
	LCD_WriteReg(0x0000,0x0001);
	delay_nms(50); // delay 50 ms 
	   
	LCD_WriteReg(0x0000,0x0001);//򿪾
	LCD_WriteReg(0x0003,0xA8A4);//0xA8A4
	LCD_WriteReg(0x000C,0x0000);    
	LCD_WriteReg(0x000D,0x080C);   
	LCD_WriteReg(0x000E,0x2B00);    
	LCD_WriteReg(0x001E,0x00B0);    
	LCD_WriteReg(0x0001,0x2B3F);//320*240  0x6B3F
	LCD_WriteReg(0x0002,0x0600);
	LCD_WriteReg(0x0010,0x0000);  
	LCD_WriteReg(0x0011,0x6070); //ݸʽ  16λɫ 		 0x6058
	LCD_WriteReg(0x0005,0x0000);  
	LCD_WriteReg(0x0006,0x0000);  
	LCD_WriteReg(0x0016,0xEF1C);  
	LCD_WriteReg(0x0017,0x0003);  
	LCD_WriteReg(0x0007,0x0233); //0x0233       
	LCD_WriteReg(0x000B,0x0000);  
	LCD_WriteReg(0x000F,0x0000); //ɨ迪ʼַ
	LCD_WriteReg(0x0041,0x0000);  
	LCD_WriteReg(0x0042,0x0000);  
	LCD_WriteReg(0x0048,0x0000);  
	LCD_WriteReg(0x0049,0x013F);  
	LCD_WriteReg(0x004A,0x0000);  
	LCD_WriteReg(0x004B,0x0000);  
	LCD_WriteReg(0x0044,0xEF00);  
	LCD_WriteReg(0x0045,0x0000);  
	LCD_WriteReg(0x0046,0x013F);  
	LCD_WriteReg(0x0030,0x0707);  
	LCD_WriteReg(0x0031,0x0204);  
	LCD_WriteReg(0x0032,0x0204);  
	LCD_WriteReg(0x0033,0x0502);  
	LCD_WriteReg(0x0034,0x0507);  
	LCD_WriteReg(0x0035,0x0204);  
	LCD_WriteReg(0x0036,0x0204);  
	LCD_WriteReg(0x0037,0x0502);  
	LCD_WriteReg(0x003A,0x0302);  
	LCD_WriteReg(0x003B,0x0302);  
	LCD_WriteReg(0x0023,0x0000);  
	LCD_WriteReg(0x0024,0x0000);  
	LCD_WriteReg(0x0025,0x8000);  
	LCD_WriteReg(0x004f,0);        //ַ0
	LCD_WriteReg(0x004e,0);        //ַ0
				 
    LCD_LEDON(); 
	LCD_Clear(WHITE);
}  
/*******************************************/
//
//Color:Ҫɫ
/******************************************/
void LCD_Clear(u16 Color)
{
	u32 index=0;      
	LCD_SetCursor(0x00,0x0000);//ùλ 
	LCD_WriteRAM_Prepare();     //ʼдGRAM	 	  
	for(index=0;index<76800;index++)
	{
		LCD_WR_DATA(Color);    
	}
} 
/****************************************/ 
//ָָɫ
//С:
//  (xend-xsta)*(yend-ysta)
/****************************************/
void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color)
{          
	u16 i,j;
	u16 xlen=0;
#ifdef USE_HORIZONTAL
	xlen=yend-ysta+1;	   
	for(i=xsta;i<=xend;i++)
	{
	 	LCD_SetCursor(i,ysta);      //ùλ 
		LCD_WriteRAM_Prepare();     //ʼдGRAM	  
		for(j=0;j<xlen;j++)LCD_WR_DATA(color);//ùλ 	  
	}
#else
	xlen=xend-xsta+1;	   
	for(i=ysta;i<=yend;i++)
	{
	 	LCD_SetCursor(xsta,i);      //ùλ 
		LCD_WriteRAM_Prepare();     //ʼдGRAM	  
		for(j=0;j<xlen;j++)LCD_WR_DATA(color);//ùλ 	    
	}
#endif						  	    
} 
/*******************************************/ 
//
//x1,y1:
//x2,y2:յ  
/******************************************/
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		LCD_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}
/******************************************/    
//
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2)
{
	LCD_DrawLine(x1,y1,x2,y1);
	LCD_DrawLine(x1,y1,x1,y2);
	LCD_DrawLine(x1,y2,x2,y2);
	LCD_DrawLine(x2,y1,x2,y2);
}
/******************************************/ 
//ָλûһָСԲ
//(x,y):ĵ
//r    :뾶
/******************************************/ 
void Draw_Circle(u16 x0,u16 y0,u8 r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		LCD_DrawPoint(x0-b,y0-a);             //3           
		LCD_DrawPoint(x0+b,y0-a);             //0           
		LCD_DrawPoint(x0-a,y0+b);             //1       
		LCD_DrawPoint(x0-b,y0-a);             //7           
		LCD_DrawPoint(x0-a,y0-b);             //2             
		LCD_DrawPoint(x0+b,y0+a);             //4               
		LCD_DrawPoint(x0+a,y0-b);             //5
		LCD_DrawPoint(x0+a,y0+b);             //6 
		LCD_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a,y0+b);
	}
}
/******************************************/  
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
//ָλʾһַ
//x:0~234
//y:0~308
//num:Ҫʾַ:" "--->"~"
//size:С 12/16
//mode:ӷʽ(1)Ƿǵӷʽ(0)
/******************************************/ 
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode)
{  
#ifdef USE_HORIZONTAL
#define MAX_CHAR_POSX 312
#define MAX_CHAR_POSY 232 
#else     
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 312
#endif 
    u8 temp;
    u8 pos,t;
	u16 x0=x;
	u16 colortemp=POINT_COLOR;      
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;	    
	//ô		   
	num=num-' ';//õƫƺֵ
	if(!mode) //ǵӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)POINT_COLOR=colortemp;
				else POINT_COLOR=BACK_COLOR;
				LCD_DrawPoint(x,y);	
				temp>>=1; 
				x++;
		    }
			x=x0;
			y++;
		}	
	}else//ӷʽ
	{
		for(pos=0;pos<size;pos++)
		{
			if(size==12)temp=asc2_1206[num][pos];//1206
			else temp=asc2_1608[num][pos];		 //1608
			for(t=0;t<size/2;t++)
		    {                 
		        if(temp&0x01)LCD_DrawPoint(x+t,y+pos);//һ     
		        temp>>=1; 
		    }
		}
	}
	POINT_COLOR=colortemp;	    	   	 	  
} 
/******************************************/   
//m^n
/******************************************/ 
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}
/******************************************/ 			 
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//color:ɫ
//num:ֵ(0~4294967295);
/******************************************/ 	 
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size)
{         	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size,0);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,0); 
	}
}
/******************************************/  
//ʾ2
//x,y:
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~99);
/******************************************/ 	 
void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode)
{         	
	u8 t,temp;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size,mode); 
	}
} 
/******************************************/ 
//ʾַ
//x,y:  
//*p:ַʼַ
//16
/******************************************/ 
void LCD_ShowString(u16 x,u16 y,const u8 *p)
{         
    while(*p!='\0')
    {       
        if(x>MAX_CHAR_POSX){x=0;y+=16;}
        if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}
        LCD_ShowChar(x,y,*p,16,0);
        x+=8;
        p++;
    }  
}
/******************************************/ 
//԰庯
/******************************************/ 
u16 RGB_Board(u16 R,u16 G,u16 B)	//԰庯
{
	u16 RGB=0x0000;

	RGB=(R<<8)|0x07ff;
    RGB=(RGB&((G<<3)|0xf800))|0x001f;
	RGB=RGB&((B>>3)|0xffe0);
	return (RGB);
}

